"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _clientLambda = require("@aws-sdk/client-lambda");
var _nodeHttpHandler = require("@smithy/node-http-handler");
var _bluebird = _interopRequireDefault(require("bluebird"));
var _log = require("../utils/log");
/* eslint import/no-extraneous-dependencies: ["error", {"devDependencies": true}] */

class Connector {
  constructor({
    debug,
    timeout = Number(process.env.LAMBDA_TIMEOUT) || Number(process.env.TIMEOUT) || 1000
  }) {
    this.debug = msg => debug('%j', msg);
    this.lambda = new _clientLambda.LambdaClient({
      requestHandler: new _nodeHttpHandler.NodeHttpHandler({
        requestTimeout: timeout,
        connectionTimeout: timeout
      }),
      logger: (0, _log.defaultDebugLogger)(debug)
    });
  }
  invoke(params) {
    return _bluebird.default.resolve(this.lambda.send(new _clientLambda.InvokeCommand(params))).tap(this.debug).tapCatch(this.debug);
  }
}
var _default = exports.default = Connector;